//Basic Line Shader

#type vertex
#version 440 core

layout(location = 0) in vec3 a_Position;
layout(location = 1) in vec4 a_Color;
layout(location = 2) in int a_GameObjectID;

uniform mat4 u_ViewProjection;
uniform mat4 u_Transform;

out vec4 v_Color;
out flat int v_GameObjectID;

void main()
{
	v_Color = a_Color;
	v_GameObjectID = a_GameObjectID;

	gl_Position = u_ViewProjection * vec4(a_Position, 1.0);	
}

#type fragment
#version 440 core

layout (location = 0) out vec4 o_DiffuseColor;
layout (location = 1) out int o_GameObjectID;

in vec4 v_Color;
in flat int v_GameObjectID;

void main()
{
	o_DiffuseColor = v_Color;
	o_GameObjectID = v_GameObjectID;
}