//Basic Texture Shader

#type vertex
#version 440 core

layout(location = 0) in vec3 a_Position;
layout(location = 1) in vec3 a_Normal;
layout(location = 2) in vec4 a_Color;
layout(location = 3) in vec2 a_TexCoord;
layout(location = 4) in int a_GameObjectID;

uniform mat4 u_ViewProjection;
uniform mat4 u_Transform;

out vec4 v_Color;
out vec2 v_TexCoord;
out flat int v_GameObjectID;

void main()
{
	v_Color = a_Color;
	v_TexCoord = a_TexCoord;
	v_GameObjectID = a_GameObjectID;

	gl_Position = u_ViewProjection * vec4(a_Position, 1.0);	
}

#type fragment
#version 440 core

layout (location = 0) out vec4 o_DiffuseColor;
layout (location = 1) out int o_GameObjectID;

in vec4 v_Color;
in vec2 v_TexCoord;
in flat int v_GameObjectID;

uniform int u_AlphaTest;
uniform int u_AlphaBlendMode;
uniform sampler2D u_Texture;

void main()
{
	vec4 texColor = v_Color;

	texColor *= texture(u_Texture, v_TexCoord);

	if(u_AlphaTest == 1)
	{
		if (texColor.a < 0.5)
			discard;
	}

	if(u_AlphaBlendMode != 1)
	{
		texColor.a = 1;
	}

	o_DiffuseColor = texColor;
	o_GameObjectID = v_GameObjectID;
}